## qtav 1.12.0%2Bds

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MULTIARCH ?= $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)
export QT_SELECT=qt5

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --parallel --buildsystem qmake

override_dh_auto_configure:
	dh_auto_configure -Sqmake -- CONFIG+="no_rpath recheck config_libass_link config_openal_link no-tests"

## qtav 1.12.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
set(QTAV_MAJOR 1)
set(QTAV_MINOR 11)
set(QTAV_PATCH 0)
set(PROJECT_VERSION ${QTAV_MAJOR}.${QTAV_MINOR}.${QTAV_PATCH})
set(SO_VERSION ${QTAV_MAJOR})

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(POLICY CMP0063) # visibility. since 3.3
  cmake_policy(SET CMP0063 NEW)
endif()
set(CMAKE_CXX_VISIBILITY_PRESET hidden) #use with -fdata-sections -ffunction-sections to reduce target size
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)


option(BUILD_EXAMPLES "Build examples" ON)
option(BUILD_PLAYERS "Build players" ON)
option(BUILD_TESTS "Build tests" ON)
option(BUILD_QT5OPENGL "Build with Qt5 OpenGL module" ON)

list(APPEND CMAKE_FIND_ROOT_PATH ${QTDIR})

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
get_target_property(qmake Qt5::qmake LOCATION)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_HEADERS
    OUTPUT_VARIABLE QT_INSTALL_HEADERS
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_LIBS
    OUTPUT_VARIABLE QT_INSTALL_LIBS
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_BINS
    OUTPUT_VARIABLE QT_INSTALL_BINS
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_QML
    OUTPUT_VARIABLE QT_INSTALL_QML
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(
    COMMAND ${qmake} -query QT_INSTALL_PREFIX
    OUTPUT_VARIABLE QT_INSTALL_PREFIX
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${QT5_CFLAGS}")

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(POLICY CMP0063) # visibility. since 3.3
  cmake_policy(SET CMP0063 NEW)
endif()
set(CMAKE_CXX_VISIBILITY_PRESET hidden) #use with -fdata-sections -ffunction-sections to reduce target size
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON) # for .moc
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)
if(NOT CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(QTAV_INSTALL_HEADERS ${CMAKE_INSTALL_PREFIX}/include)
  set(QTAV_INSTALL_LIBS ${CMAKE_INSTALL_PREFIX}/lib)
  set(QTAV_INSTALL_BINS ${CMAKE_INSTALL_PREFIX}/bin)
  set(QTAV_INSTALL_QML ${CMAKE_INSTALL_PREFIX}/qml)
else()
  set(CMAKE_INSTALL_PREFIX ${QT_INSTALL_PREFIX} CACHE PATH "default install path" FORCE)
  set(QTAV_INSTALL_HEADERS ${QT_INSTALL_HEADERS})
  set(QTAV_INSTALL_LIBS ${QT_INSTALL_LIBS})
  set(QTAV_INSTALL_BINS ${QT_INSTALL_BINS})
  set(QTAV_INSTALL_QML ${QT_INSTALL_QML})
endif()

message(STATUS "Qt version: ${Qt5Core_VERSION_STRING}")
message(STATUS "Qt prefix: ${QT_INSTALL_PREFIX}")
message(STATUS "QtAV headers prefix: ${QTAV_INSTALL_HEADERS}")
message(STATUS "QtAV libs prefix: ${QTAV_INSTALL_LIBS}")
message(STATUS "QtAV bins prefix: ${QTAV_INSTALL_BINS}")
message(STATUS "QtAV qml prefix: ${QTAV_INSTALL_QML}")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

#set(CMAKE_DEBUG_POSTFIX d)

install(FILES
  cmake/FindQtAV.cmake
  DESTINATION ${QTAV_INSTALL_LIBS}/cmake
)

if(CMAKE_GENERATOR MATCHES "Visual Studio.*")
  set(UCRT_INCLUDE $ENV{UniversalCRTSDKDir}Include\\$ENV{UCRTVersion}\\ucrt)
  set(VC_ARCH $ENV{Platform})
  if(NOT VC_ARCH)
    set(VC_ARCH x86)
  endif()
  set(UCRT_LIB $ENV{UniversalCRTSDKDir}Lib\\$ENV{UCRTVersion}\\ucrt\\${VC_ARCH})
  if(EXISTS ${UCRT_INCLUDE})
  message("VS project. ucrt: ${UCRT_LIB}")
    include_directories(${UCRT_INCLUDE})
    link_libraries(${CMAKE_LIBRARY_PATH_FLAG}${UCRT_LIB})
  endif()
endif()

add_subdirectory(src)
find_package(Qt5Widgets)
if(Qt5Widgets_FOUND)
  add_subdirectory(widgets)
endif()
find_package(Qt5 COMPONENTS Qml Quick)
if(Qt5Qml_FOUND AND Qt5Quick_FOUND)
  add_subdirectory(qml)
endif()

if(BUILD_EXAMPLES OR BUILD_PLAYERS)
  add_subdirectory(examples)
endif()

=== qml/CMakeLists.txt ===
set(MODULE QmlAV)
set(EXTRA_DEFS -DBUILD_QMLAV_LIB)

#URI = QtAV #uri used in QtAVQmlPlugin::registerTypes(uri)
#qtAtLeast(5, 3): QMAKE_MOC_OPTIONS += -Muri=$$URI # not sure what moc does
set(HEADERS
    QmlAV/Export.h
    QmlAV/MediaMetaData.h
    QmlAV/SGVideoNode.h
    QmlAV/QQuickItemRenderer.h
    QmlAV/QuickFilter.h
    QmlAV/QmlAVPlayer.h
    QmlAV/QuickSubtitle.h
    QmlAV/QuickSubtitleItem.h
    QmlAV/QuickVideoPreview.h
)
set(SOURCES
    plugin.cpp
    QQuickItemRenderer.cpp
    SGVideoNode.cpp
    QmlAVPlayer.cpp
    QuickFilter.cpp
    QuickSubtitle.cpp
    MediaMetaData.cpp
    QuickSubtitleItem.cpp
    QuickVideoPreview.cpp
)
if(NOT Qt5Qml_VERSION VERSION_LESS 5.2.0)
  list(APPEND HEADERS QmlAV/QuickFBORenderer.h)
  list(APPEND SOURCES QuickFBORenderer.cpp)
endif()
# add HEADERS for moc
if(WIN32)
  set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
  configure_file(${CMAKE_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
endif()
add_library(${MODULE} SHARED ${SOURCES} ${RESOURCES_SOURCES} ${HEADERS} ${RC_FILE})
target_link_libraries(${MODULE}
  LINK_PRIVATE ${EXTRA_LIBS}
  LINK_PUBLIC QtAV Qt5::Qml Qt5::Quick
)
set_target_properties(${MODULE} PROPERTIES
  OUTPUT_NAME ${MODULE}
  CLEAN_DIRECT_OUTPUT 1
  #LINK_SEARCH_START_STATIC 1
  MACOSX_RPATH ON
  FRAMEWORK OFF
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/QtAV
  RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/QtAV
)

#http://stackoverflow.com/questions/19866424/cmake-and-qt5-automoc-error
#http://doc.qt.io/qt-5/cmake-manual.html
set(CMAKE_INCLUDE_CURRENT_DIR ON) # for .moc
target_include_directories(${MODULE}
  PUBLIC $<INSTALL_INTERFACE:include>
  PUBLIC $<INSTALL_INTERFACE:include/${MODULE}>
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}>
  PRIVATE ${EXTRA_INCLUDE}
  )
target_compile_definitions(${MODULE} PRIVATE ${EXTRA_DEFS})
set(QML_FILES qmldir Video.qml plugins.qmltypes)
add_custom_command(TARGET ${MODULE} POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/bin/QtAV
  COMMAND ${CMAKE_COMMAND} -E copy_if_different ${QML_FILES} ${CMAKE_BINARY_DIR}/bin/QtAV
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

install(TARGETS ${MODULE}
  EXPORT ${MODULE}-targets
  RUNTIME DESTINATION ${QTAV_INSTALL_QML}/QtAV
  LIBRARY DESTINATION ${QTAV_INSTALL_QML}/QtAV
  ARCHIVE DESTINATION ${QTAV_INSTALL_QML}/QtAV
  FRAMEWORK DESTINATION ${QTAV_INSTALL_LIBS}
)
install(EXPORT ${MODULE}-targets
  DESTINATION ${QTAV_INSTALL_LIBS}/cmake/${MODULE}
  FILE ${MODULE}-config.cmake
)
install(
  FILES ${QML_FILES}
  DESTINATION ${QTAV_INSTALL_QML}/QtAV
)

=== src/CMakeLists.txt ===
set(MODULE QtAV)
# TODO: translations, rpath, uchardet, x11extras, android

include(CheckCCompilerFlag)
include(CheckCXXSourceCompiles)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckLibraryExists)
INCLUDE(CheckTypeSize)

# set qt dirs first so we can find depends in qt install dir
include_directories(${QTDIR}/include) #TODO: remove. use external/include
get_filename_component(QTDIR "${QTDIR}" ABSOLUTE)

list(APPEND EXTRA_INCLUDE ${CMAKE_SOURCE_DIR}/external/include)
list(APPEND EXTRA_LIBS ${CMAKE_LIBRARY_PATH_FLAG}${CMAKE_SOURCE_DIR}/external/lib)
if(APPLE)
    if(IOS)
      #set_xcode_property(myioslib IPHONEOS_DEPLOYMENT_TARGET "8.0")
    else()
      list(APPEND EXTRA_INCLUDE /usr/local/include) #macOS only
      list(APPEND EXTRA_LIBS -L/usr/local/lib)
    endif()
endif()
if(EXISTS ${CMAKE_SOURCE_DIR}/contrib/capi/capi.h)
    set(HAVE_CAPI 1)
    list(APPEND EXTRA_INCLUDE ${CMAKE_SOURCE_DIR}/contrib/capi) # TODO: only files use capi.h
    list(APPEND EXTRA_DEFS -DQTAV_HAVE_CAPI=1)
endif()

# check ffmpeg headers. assume libs exist. lib order matters if they are static
set(AVMODULES avformat avcodec swscale avutil) # avdevice avfilter avresample swscale)
# CMAKE_FIND_ROOT_PATH_BOTH: ensure find_file can search from given paths for cross compiling, may be set to ONLY in toolchain file
foreach(av ${AVMODULES})
    string(TOUPPER ${av} AV)
    find_file(HAVE_${AV} lib${av}/${av}.h HINTS ${EXTRA_INCLUDE} PATHS ${EXTRA_INCLUDE} CMAKE_FIND_ROOT_PATH_BOTH)
    message("HAVE_${AV}: ${HAVE_${AV}}")
    if(NOT ${HAVE_${AV}} MATCHES HAVE_${AV}-NOTFOUND)
      set(HAVE_${AV} 1)
      list(APPEND EXTRA_LIBS ${av})
      list(APPEND EXTRA_DEFS "-DQTAV_HAVE_${AV}=1")
    else()
      message(FATAL_ERROR "${av} is required")
    endif()
    #check_include_file(lib${av}/${av}.h HAVE_${AV}) # -D__STDC_CONSTANT_MACROS is required!
endforeach()

foreach(av avfilter avdevice avresample swresample)
  string(TOUPPER ${av} AV)
  find_file(HAVE_${AV} lib${av}/${av}.h HINTS ${EXTRA_INCLUDE} PATHS ${EXTRA_INCLUDE} CMAKE_FIND_ROOT_PATH_BOTH)
  message("HAVE_${AV}: ${HAVE_${AV}}")
  if(NOT ${HAVE_${AV}} MATCHES HAVE_${AV}-NOTFOUND)
    set(HAVE_${AV} 1)
    list(APPEND EXTRA_LIBS ${av})
    list(APPEND EXTRA_DEFS "-DQTAV_HAVE_${AV}=1")
    list(APPEND AVMODULES ${av})
  endif()
endforeach()

if (NOT HAVE_SWRESAMPLE)
  if (NOT HAVE_AVRESAMPLE)
    message(FATAL_ERROR "swresample or avresample is required")
  endif()
endif()

list(APPEND EXTRA_DEFS -DBUILD_QTAV_LIB -D__STDC_CONSTANT_MACROS)

check_include_file(ass/ass.h HAVE_ASS_H)
if(HAVE_ASS_H)
  if(HAVE_CAPI) # dynamic load
    if(IOS OR ANDROID OR WindowsPhone OR WindowsStore)
    else()
      set(HAVE_ASS 1)
    endif()
  endif()
  if(NOT HAVE_ASS) # link to ass
    check_library_exists(ass ass_library_init "" HAVE_ASS)
    if(HAVE_ASS)
      set(DYNAMIC_ASS 0)
      list(APPEND EXTRA_DEFS -DCAPI_LINK_ASS)
      list(APPEND EXTRA_LIBS ass)
    endif()
  endif()
endif()
if(HAVE_ASS)
  list(APPEND EXTRA_DEFS -DQTAV_HAVE_LIBASS=1)
  list(APPEND SOURCES
    capi/ass_api.cpp
    subtitle/SubtitleProcessorLibASS.cpp
  )
endif()

set(DYNAMIC_OPENAL ${HAVE_CAPI})
if(APPLE)
  set(HAVE_OPENAL 1)
  if(NOT DYNAMIC_OPENAL)
    list(APPEND EXTRA_LIBS "-framework OpenAL")
  endif()
  list(APPEND EXTRA_DEFS -DHEADER_OPENAL_PREFIX)
else()
  set(OLD_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
  set(CMAKE_REQUIRED_INCLUDES ${EXTRA_INCLUDE})
  check_include_files(AL/al.h HAVE_AL_H)
  set(CMAKE_REQUIRED_INCLUDES ${OLD_REQUIRED_INCLUDES})
  if(HAVE_AL_H)
    if(HAVE_CAPI) #TODO: option(LINK_OPENAL...)
      set(HAVE_OPENAL 1)
      # DYNAMIC_OPENAL is set by user
    else()
      if(WIN32)
        check_library_exists(OpenAL alGetError "" HAVE_OPENAL)
      else()
        check_library_exists(openal alGetError "" HAVE_OPENAL)
        if(NOT HAVE_OPENAL)
            check_library_exists(OpenAL alGetError "" HAVE_OPENAL) # blackberry
            if(HAVE_OPENAL)
              list(APPEND EXTRA_LIBS OpenAL)
            endif()
        else()
            list(APPEND EXTRA_LIBS openal)
        endif()
      endif()
      if(HAVE_OPENAL)
        set(DYNAMIC_OPENAL 0)
      endif()
    endif()
  endif()
endif()
if(HAVE_OPENAL AND NOT DYNAMIC_OPENAL)
  list(APPEND EXTRA_DEFS -DCAPI_LINK_OPENAL)
endif()
if(HAVE_OPENAL)
  list(APPEND SOURCES
    capi/openal_api.cpp
    output/audio/AudioOutputOpenAL.cpp
    )
endif()

if (APPLE)
  set(CMAKE_CXX_SYSTEM_FRAMEWORK_SEARCH_FLAG "-F ") # original is "-iframework", lots of build errors
  set(CMAKE_C_SYSTEM_FRAMEWORK_SEARCH_FLAG "-F ")
  set(OLD_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} avcodec)
  check_c_source_compiles(
    "#include <libavcodec/videotoolbox.h>
    int main() {
        av_videotoolbox_alloc_context();
        return 0;
    }" HAVE_VIDEOTOOLBOX)
  set(CMAKE_REQUIRED_LIBRARIES ${OLD_REQUIRED_LIBRARIES})

  if (HAVE_VIDEOTOOLBOX)
    list(APPEND EXTRA_DEFS -DQTAV_HAVE_VIDEOTOOLBOX=1)
    list(APPEND EXTRA_LIBS "-framework CoreMedia" "-framework VideoToolbox" "-framework CoreVideo")
    list(APPEND SOURCES 
      codec/video/VideoDecoderVideoToolbox.cpp
      codec/video/SurfaceInteropCV.cpp
      )
    if (IOS)
      list(APPEND SOURCES 
        codec/video/SurfaceInteropCVOpenGLES.mm
        )
    else()
      list(APPEND SOURCES 
        codec/video/SurfaceInteropIOSurface.cpp
        )
    endif()
  endif()

  list(APPEND SOURCES output/audio/AudioOutputAudioToolbox.cpp)
  list(APPEND EXTRA_LIBS "-framework CoreFoundation" "-framework AudioToolbox" "-framework OpenGL")
endif()

set(DEP_H  OPENAL VIDEOTOOLBOX)
foreach (D ${DEP_H})
  if (${D})
    ADD_DEFINITIONS(-DQTAV_HAVE_${D}=1)
  endif()
endforeach()

if (HAVE_AVRESAMPLE)
  list(APPEND SOURCES AudioResamplerLibav.cpp)
endif()
if (HAVE_SWRESAMPLE)
  list(APPEND SOURCES AudioResamplerFF.cpp)
endif()

set(HAVE_EGL 0)
set(DYNAMIC_GL 0)
set(OPENGL 0)     #desktop opengl only
set(OPENGLES 0)   #glesv2 only
set(HAVE_OPENGL 1) # qt with opengl enabled. 1 of DYNAMIC_GL, OPENGL and OPENGLES is true
#get_target_property(QtGui_location Qt5::Gui LOCATION) #dll path

if(Qt5Gui_OPENGL_IMPLEMENTATION STREQUAL GL) # windows always set to GL
  if(EXISTS ${QT_INSTALL_HEADERS}/QtANGLE)
    set(DYNAMIC_GL 1) # assume Qt5Gui_OPENGL_IMPLEMENTATION is not GL if build with ANGLE only
    if(NOT DEFINED Qt5Gui_EGL_INCLUDE_DIRS)
      set(Qt5Gui_EGL_INCLUDE_DIRS ${QT_INSTALL_HEADERS}/QtANGLE)
    endif()
  else()
    set(OPENGL 1)
  endif()
  if(DEFINED Qt5Gui_EGL_LIBRARIES) # x11?
    set(HAVE_EGL 1)
  endif()
else()
  set(OPENGLES 1)
endif()
if(OPENGLES OR DYNAMIC_GL)
  set(HAVE_EGL 1)
endif()
if(NOT OPENGL AND NOT OPENGLES AND NOT DYNAMIC_GL)
  set(HAVE_OPENGL 0)
endif()
if(HAVE_OPENGL)
  if(WIN32 AND NOT DYNAMIC_GL AND NOT OPENGLES) # msys2
    find_package(OpenGL REQUIRED)
    list(APPEND EXTRA_LIBS ${OPENGL_gl_LIBRARY})
  endif()
endif()

file(GLOB SDK_HEADERS QtAV/*.h)
list(APPEND SDK_HEADERS QtAV/QtAV)
file(GLOB SDK_PRIVATE_HEADERS QtAV/private/*.h)

list(APPEND SOURCES
    AVCompat.cpp
    QtAV_Global.cpp
    subtitle/CharsetDetector.cpp
    subtitle/PlainText.cpp
    subtitle/PlayerSubtitle.cpp
    subtitle/Subtitle.cpp
    subtitle/SubtitleProcessor.cpp
    subtitle/SubtitleProcessorFFmpeg.cpp
    subtitle/SubImage.cpp
    utils/GPUMemCopy.cpp
    utils/Logger.cpp
    AudioThread.cpp
    utils/internal.cpp
    AVThread.cpp
    AudioFormat.cpp
    AudioFrame.cpp
    AudioResampler.cpp
    AudioResamplerTemplate.cpp
    codec/audio/AudioDecoder.cpp
    codec/audio/AudioDecoderFFmpeg.cpp
    codec/audio/AudioEncoder.cpp
    codec/audio/AudioEncoderFFmpeg.cpp
    codec/AVDecoder.cpp
    codec/AVEncoder.cpp
    AVMuxer.cpp
    AVDemuxer.cpp
    AVDemuxThread.cpp
    ColorTransform.cpp
    Frame.cpp
    FrameReader.cpp
    filter/Filter.cpp
    filter/FilterContext.cpp
    filter/FilterManager.cpp
    filter/LibAVFilter.cpp
    filter/SubtitleFilter.cpp
    filter/EncodeFilter.cpp
    ImageConverter.cpp
    ImageConverterFF.cpp
    Packet.cpp
    PacketBuffer.cpp
    AVError.cpp
    AVPlayer.cpp
    AVPlayerPrivate.cpp
    AVTranscoder.cpp
    AVClock.cpp
    VideoCapture.cpp
    VideoFormat.cpp
    VideoFrame.cpp
    io/MediaIO.cpp
    io/QIODeviceIO.cpp
    output/audio/AudioOutput.cpp
    output/audio/AudioOutputBackend.cpp
    output/audio/AudioOutputNull.cpp
    output/video/VideoRenderer.cpp
    output/video/VideoOutput.cpp
    output/video/QPainterRenderer.cpp
    output/AVOutput.cpp
    output/OutputSet.cpp
    Statistics.cpp
    codec/video/VideoDecoder.cpp
    codec/video/VideoDecoderFFmpegBase.cpp
    codec/video/VideoDecoderFFmpeg.cpp
    codec/video/VideoDecoderFFmpegHW.cpp
    codec/video/VideoEncoder.cpp
    codec/video/VideoEncoderFFmpeg.cpp
    VideoThread.cpp
    VideoFrameExtractor.cpp
    )

if(HAVE_OPENGL)
  aux_source_directory(opengl SRC_OPENGL) 
  list(APPEND SOURCES ${SRC_OPENGL})
  list(APPEND SOURCES
    filter/GLSLFilter.cpp
    output/video/OpenGLRendererBase.cpp
  )
  if(NOT Qt5Gui_VERSION VERSION_LESS 5.4.0)
    list(APPEND SDK_HEADERS QtAV/OpenGLWindowRenderer.h)
    list(APPEND SOURCES output/video/OpenGLWindowRenderer.cpp)
  endif()
endif()

if(HAVE_EGL)
  list(APPEND SOURCES capi/egl_api.cpp)
  # TODO: X11Extras
  if(DEFINED Qt5Gui_EGL_INCLUDE_DIRS) # ANGLE
    list(APPEND EXTRA_INCLUDE ${Qt5Gui_EGL_INCLUDE_DIRS})
    #list(APPEND EXTRA_DEFS -DQTAV_HAVE_QT_EGL=1)
    if(HAVE_CAPI AND NOT IOS)
      list(APPEND EXTRA_DEFS -DQTAV_HAVE_EGL_CAPI=1)
      if(WindowsPhone OR WindowsStore)
        list(APPEND EXTRA_DEFS -DCAPI_LINK_EGL)
      endif()
    endif()
  endif()
endif()
if(WIN32 OR WindowsStore OR WindowsPhone)
  check_include_files(XAudio2.h HAVE_XAUDIO2_H)
  if(NOT HAVE_XAUDIO2_H)
    list(APPEND EXTRA_INCLUDE ${CMAKE_SOURCE_DIR}/contrib/dxsdk)
  endif()
  message("Qt5Gui_EGL_INCLUDE_DIRS: ${Qt5Gui_EGL_INCLUDE_DIRS}")
  list(APPEND HEADERS
    output/audio/xaudio2_compat.h
    codec/video/VideoDecoderD3D.h
  )
  list(APPEND SOURCES
    utils/DirectXHelper.cpp
    output/audio/AudioOutputXAudio2.cpp
    codec/video/VideoDecoderD3D.cpp
  )
  list(APPEND EXTRA_DEFS -DQTAV_HAVE_XAUDIO2=1)
  set(OLD_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} avcodec) # TODO: lib dir
  set(OLD_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
  set(CMAKE_REQUIRED_INCLUDES ${EXTRA_INCLUDE} ${CMAKE_CURRENT_SOURCE_DIR})
  check_cxx_source_compiles("
  #include \"directx/dxcompat.h\"
  #include <d3d11.h>
  extern \"C\" {
  #include <libavcodec/d3d11va.h>
  }
  #include <wrl/client.h> //ComPtr is used in QtAV
  int main() {
    av_d3d11va_alloc_context();
    D3D11_VIDEO_PROCESSOR_STREAM s; //used by vp
    return 0;
  }
  " HAVE_D3D11)
  set(CMAKE_REQUIRED_INCLUDES ${OLD_REQUIRED_INCLUDES})
  set(CMAKE_REQUIRED_LIBRARIES ${OLD_REQUIRED_LIBRARIES})
  if(HAVE_D3D11)
    # https://crascit.com/2015/03/28/enabling-cxx11-in-cmake/ (global and specified target)
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    list(APPEND EXTRA_DEFS -DQTAV_HAVE_D3D11VA=1)
    list(APPEND SOURCES
      codec/video/VideoDecoderD3D11.cpp
      directx/SurfaceInteropD3D11.cpp
      directx/D3D11VP.cpp
    )
    if(HAVE_EGL)
      list(APPEND SOURCES directx/SurfaceInteropD3D11EGL.cpp)
    endif()
    if(HAVE_OPENGL AND NOT OPENGLES) # dynamic gl or desktop
      list(APPEND SOURCES directx/SurfaceInteropD3D11GL.cpp)
    endif()
  endif()
  if(WindowsStore OR WindowsPhone)
    list(APPEND SOURCES io/WinRTIO.cpp)
    list(APPEND EXTRA_LIBS
      xaudio2 #only for xbox or >=win8
      shcore
    )
    if(HAVE_D3D11)
      list(APPEND EXTRA_LIBS d3d11)
    endif()
  else()
    list(APPEND EXTRA_LIBS ole32 user32) #ole32: CoInitializeEx for vs2008, but can not find the symbol at runtime
    list(APPEND SOURCES
      output/audio/AudioOutputDSound.cpp
      directx/SurfaceInteropD3D9.cpp
      codec/video/VideoDecoderDXVA.cpp
    )

=== debian/changelog ===
qtav (1.12.0+ds-5) unstable; urgency=medium

  * Team upload.
  * Switch Vcs-* fields to salsa.debian.org.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11
    - remove --parallel for dh, as now done by default
  * Bump Standards-Version to 4.1.5, no changes required.
  * Fix build with FFmpeg >= 4.0. (Closes: #888367)
  * Remove empty line at the end of rules.

 -- Pino Toscano <pino@debian.org>  Wed, 18 Jul 2018 09:12:03 +0200

qtav (1.12.0+ds-4) unstable; urgency=medium

  * Team upload.
  * Disable libva-dev on Hurd, since it is not available there.
  * Try to load the libva* libraries with SONAME 2 (Closes: #880884)

 -- Pino Toscano <pino@debian.org>  Thu, 23 Nov 2017 19:55:30 +0100

qtav (1.12.0+ds-3) unstable; urgency=medium

  * Team upload.

  [ Steve M. Robbins ]
  * Update standards-version to 4.1.1.  Add Vcs-* fields.

  [ Pino Toscano ]
  * Remove manual library and va-driver dependencies. (Closes: #880884)
  * Specify the buildsystem as qmake.
  * Use dh_auto_configure in its override.
  * Link in as-needed mode.

 -- Pino Toscano <pino@debian.org>  Fri, 10 Nov 2017 22:36:00 +0100

qtav (1.12.0+ds-2) unstable; urgency=medium

  * [3bbd7b5] Declare libqtav1 and libqtavwidgets1 as Section: libs
  * [a1046d3] Mark qtav-players as multi-arch "no" since binaries are
    installed into not-arch-specific directory /usr/lib/qt5/bin.

 -- Steve M. Robbins <smr@debian.org>  Sat, 04 Nov 2017 21:36:00 -0500

qtav (1.12.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #737016)

 -- Steve M. Robbins <smr@debian.org>  Sun, 27 Aug 2017 23:06:54 -0500

=== debian/control ===
Source: qtav
Maintainer: Debian Qt extras Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>
Section: video
Priority: optional
Build-Depends: debhelper (>= 11~),
               qt5-qmake,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               qtdeclarative5-dev,
               libqt5x11extras5-dev,
               libass-dev,
               libavutil-dev,
               libavresample-dev,
               libavcodec-dev,
               libavformat-dev,
               libavdevice-dev,
               libavfilter-dev,
               libswscale-dev,
               libopenal-dev,
               libpulse-dev,
               libxv-dev,
               libva-dev [!hurd-any],
               libegl1-mesa-dev,
               libuchardet-dev
Standards-Version: 4.1.5
Homepage: http://qtav.org
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qtav
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qtav.git

Package: libqtav1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
Pre-Depends: ${misc:Pre-Depends}
Description: QtAV library
 QtAV is a multimedia playback library based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
 This package contains the QtAV library.

Package: libqtavwidgets1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: QtAV Widgets module
 QtAV is a multimedia playback library based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
  This package contains a set of widgets to play media.

Package: libqtav-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libqtav1 (= ${binary:Version}),
         libqtavwidgets1 (= ${binary:Version}),
         libqt5opengl5-dev
Description: QtAV development files
 QtAV is a multimedia playback framework based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
 This package contains the header development files for building some
 QtAV applications using QtAV headers.

Package: libqtav-private-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libqtav-dev (= ${binary:Version}),
         ${misc:Depends}
Description: QtAV private development files
 QtAV is a multimedia playback library based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
 This package contains the private header development files for building some
 QtAV applications using QtAV private headers.
 .
 Use at your own risk.

Package: qml-module-qtav
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: QtAV QML module
 QtAV is a multimedia playback library based on Qt and FFmpeg.
 It can help you to write a player with less effort than ever before.
 .
 This package contains the QtAV QML module for Qt declarative.

Package: qtav-players
Architecture: any
Multi-Arch: no
Section: video
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtav,
	 qml-module-qtquick-dialogs,
	 qml-module-qtquick-controls,
	 qml-module-qt-labs-folderlistmodel
Pre-Depends: ${misc:Pre-Depends}
Description: QtAV/QML players
 QtAV is a multimedia playback framework based on Qt and FFmpeg.
 High performance. User & developer friendly.
 .
 This package contains the QtAV based players

=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,7 @@
 export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
 
 %:
-	dh $@ --parallel --buildsystem qmake
+	dh $@ --buildsystem qmake
 
 override_dh_auto_configure:
 	dh_auto_configure -Sqmake -- CONFIG+="no_rpath recheck config_libass_link config_openal_link no-tests"
-

=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds$//,repacksuffix=+ds,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/ \
  https://github.com//wang-bin/QtAV/tags .*/v?(\d\S+)\.tar\.gz

## qtav 1.12.0.1+ds+rb2

=== examples/CMakeLists.txt ===
find_package(Qt5Sql REQUIRED)
if(WIN32)
  set(EXE_TYPE WIN32)
elseif(APPLE)
  #set(EXE_TYPE MACOSX_BUNDLE)
endif()
set(COMMON_SRC
  common/common.cpp
  common/Config.cpp
  common/qoptions.cpp
)
set(COMMON_HEADERS
  common/common.h
  common/Config.h
  common/qoptions.h
  common/ScreenSaver.h
  common/common_export.h
)
if(NOT IOS)
  list(APPEND COMMON_SRC common/ScreenSaver.cpp)
  if(APPLE)
    list(APPEND COMMON_LIBS "-framework CoreServices")
  endif()
endif()

SET(COMMON_QRC common/theme/theme.qrc)
SOURCE_GROUP("Resources" FILES ${COMMON_QRC})
qt5_add_resources(COMMON_RES ${COMMON_QRC})
set_source_files_properties(${COMMON_RES} PROPERTIES GENERATED ON)

# add HEADERS for moc
add_library(common STATIC ${COMMON_SRC} ${COMMON_RES} ${COMMON_HEADERS})
target_link_libraries(common
  LINK_PUBLIC Qt5::Core Qt5::Gui ${COMMON_LIBS}
  LINK_PRIVATE Qt5::Sql
)
target_compile_definitions(common PUBLIC -DBUILD_COMMON_STATIC)
target_include_directories(common PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

set(PLAYER_SRC
    player/main.cpp
    player/MainWindow.cpp
    player/ClickableMenu.cpp
    player/StatisticsView.cpp
    player/Slider.cpp
    player/TVView.cpp
    player/EventFilter.cpp
    player/config/ConfigDialog.cpp
    player/config/ConfigPageBase.cpp
    player/config/CaptureConfigPage.cpp
    player/config/VideoEQConfigPage.cpp
    player/config/DecoderConfigPage.cpp
    player/config/MiscPage.cpp
    player/filters/OSD.cpp
    player/filters/OSDFilter.cpp
    player/playlist/PlayListModel.cpp
    player/playlist/PlayListItem.cpp
    player/playlist/PlayListDelegate.cpp
    player/playlist/PlayList.cpp
    player/config/PropertyEditor.cpp
    player/config/AVFormatConfigPage.cpp
    player/config/AVFilterConfigPage.cpp
    player/config/ShaderPage.cpp
    player/filters/AVFilterSubtitle.cpp
)
set(PLAYER_HEADERS
    player/MainWindow.h
    player/ClickableMenu.h
    player/StatisticsView.h
    player/Slider.h
    player/TVView.h
    player/EventFilter.h
    player/config/ConfigDialog.h
    player/config/ConfigPageBase.h
    player/config/CaptureConfigPage.h
    player/config/VideoEQConfigPage.h
    player/config/DecoderConfigPage.h
    player/config/MiscPage.h
    player/filters/OSD.h
    player/filters/OSDFilter.h
    player/playlist/PlayListModel.h
    player/playlist/PlayListItem.h
    player/playlist/PlayListDelegate.h
    player/playlist/PlayList.h
    player/config/PropertyEditor.h
    player/config/AVFormatConfigPage.h
    player/config/AVFilterConfigPage.h
    player/config/ShaderPage.h
    player/filters/AVFilterSubtitle.h
)

SET(PLAYER_QRC player/res/player.qrc)
SOURCE_GROUP("Resources" FILES ${PLAYER_QRC})
qt5_add_resources(PLAYER_RES ${PLAYER_QRC})
set_source_files_properties(${PLAYER_RES} PROPERTIES GENERATED ON)

if(Qt5Quick_FOUND)
  set(QMLPLAYER_QRC QMLPlayer/qmlplayer.qrc)
  qt5_add_resources(QMLPLAYER_RES ${QMLPLAYER_QRC})
  set_source_files_properties(${QMLPLAYER_RES} PROPERTIES GENERATED ON)
  set(MODULE QMLPlayer)
  if(WIN32)
    set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
    configure_file(${CMAKE_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
  endif()
  add_executable(QMLPlayer ${EXE_TYPE}
      QMLPlayer/main.cpp
      QMLPlayer/qtquick2applicationviewer/qtquick2applicationviewer.cpp
      QMLPlayer/qtquick2applicationviewer/qtquick2applicationviewer.h
      ${QMLPLAYER_RES}
      ${RC_FILE}
      )
  target_include_directories(QMLPlayer PRIVATE QMLPlayer/qtquick2applicationviewer)
  target_link_libraries(QMLPlayer Qt5::Quick common)
  install(TARGETS QMLPlayer
    RUNTIME DESTINATION ${QTAV_INSTALL_BINS}
  )
endif()
if(Qt5Widgets_FOUND)
  set(MODULE Player)
  if(WIN32)
    set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
    configure_file(${CMAKE_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
  endif()
  add_executable(Player ${EXE_TYPE} ${PLAYER_SRC} ${PLAYER_HEADERS} ${PLAYER_RES} ${RC_FILE})
  target_link_libraries(Player QtAVWidgets common)

  install(TARGETS Player
    RUNTIME DESTINATION ${QTAV_INSTALL_BINS}
  )
  if(BUILD_EXAMPLES)
    SET(FILTERS_QRC filters/res.qrc)
    SOURCE_GROUP("Resources" FILES ${FILTERS_QRC})
    qt5_add_resources(FILTERS_RES ${FILTERS_QRC})
    set_source_files_properties(${FILTERS_RES} PROPERTIES GENERATED ON)
    add_executable(filters filters/main.cpp filters/SimpleFilter.cpp ${FILTERS_RES})
    target_link_libraries(filters QtAVWidgets)

    add_executable(glslfilter glslfilter/main.cpp)
    target_link_libraries(glslfilter QtAVWidgets)

    add_executable(shader shader/main.cpp)
    target_link_libraries(shader QtAVWidgets)

    add_executable(sharedoutput sharedoutput/main.cpp sharedoutput/widget.cpp)
    target_link_libraries(sharedoutput QtAVWidgets)

    add_executable(simpleplayer simpleplayer/main.cpp simpleplayer/playerwindow.cpp)
    target_link_libraries(simpleplayer QtAVWidgets)

    add_executable(videocapture videocapture/main.cpp videocapture/playerwindow.cpp)
    target_link_libraries(videocapture QtAVWidgets)

    add_executable(videographicsitem videographicsitem/main.cpp videographicsitem/videoplayer.cpp)
    target_link_libraries(videographicsitem QtAVWidgets)

    add_executable(videogroup videogroup/main.cpp videogroup/videogroup.cpp)
    target_link_libraries(videogroup QtAVWidgets)

    add_executable(videowall videowall/main.cpp videowall/VideoWall.cpp)
    target_link_libraries(videowall QtAVWidgets)

    add_executable(simpletranscode simpletranscode/main.cpp)
    target_link_libraries(simpletranscode QtAV)
  endif()
endif()

if(BUILD_EXAMPLES)
  add_executable(audiopipeline audiopipeline/main.cpp)
  target_link_libraries(audiopipeline QtAV)

  add_executable(framereader framereader/main.cpp)
  target_link_libraries(framereader QtAV)

  add_executable(window window/main.cpp)
  target_link_libraries(window QtAV)
endif()

=== widgets/CMakeLists.txt ===
set(MODULE QtAVWidgets)
set(EXTRA_DEFS -DBUILD_QTAVWIDGETS_LIB)
list(APPEND EXTRA_DEFS -DQTAV_HAVE_GL=1)

set(HAVE_QT5OPENGL 0)
if(BUILD_QT5OPENGL)
  find_package(Qt5OpenGL)
  if(Qt5OpenGL_FOUND)
    set(HAVE_QT5OPENGL 1)
  endif()
endif()

set(SDK_HEADERS
  QtAVWidgets/global.h
  QtAVWidgets/GraphicsItemRenderer.h
  QtAVWidgets/OpenGLWidgetRenderer.h
  QtAVWidgets/QtAVWidgets
  QtAVWidgets/QtAVWidgets.h
  QtAVWidgets/version.h
  QtAVWidgets/VideoPreviewWidget.h
  QtAVWidgets/WidgetRenderer.h
)
file(GLOB SDK_PRIVATE_HEADERS QtAVWidgets/*.h)

set(SOURCES
  global.cpp
  GraphicsItemRenderer.cpp
  OpenGLWidgetRenderer.cpp
  VideoPreviewWidget.cpp
  WidgetRenderer.cpp
)
if(HAVE_QT5OPENGL)
  list(APPEND SDK_HEADERS QtAVWidgets/GLWidgetRenderer2.h)
  list(APPEND SOURCES GLWidgetRenderer2.cpp)
endif()

# TODO: Qt5Gui_OPENGL_IMPLEMENTATION?
if(Qt5Gui_VERSION VERSION_LESS 5.4.0)
  list(APPEND SDK_HEADERS QtAVWidgets/QOpenGLWidget.h)
  list(APPEND SOURCES QOpenGLWidget.cpp)
endif()

set(HEADERS ${SDK_HEADERS})
if(WIN32)
  set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
  configure_file(${CMAKE_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
endif()
# add HEADERS for moc
add_library(${MODULE} SHARED ${SOURCES} ${RESOURCES_SOURCES} ${HEADERS} ${RC_FILE})
target_link_libraries(${MODULE}
  LINK_PRIVATE ${EXTRA_LIBS}
  LINK_PUBLIC QtAV Qt5::Widgets
)
if(HAVE_QT5OPENGL)
  target_link_libraries(${MODULE} LINK_PUBLIC Qt5::OpenGL)
endif()
set_target_properties(${MODULE} PROPERTIES
  MACOSX_RPATH ON
  FRAMEWORK ON
  VERSION ${PROJECT_VERSION}
  SOVERSION ${SO_VERSION}
  OUTPUT_NAME ${MODULE}
  CLEAN_DIRECT_OUTPUT 1
  #LINK_SEARCH_START_STATIC 1
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib
)


#http://stackoverflow.com/questions/19866424/cmake-and-qt5-automoc-error
#http://doc.qt.io/qt-5/cmake-manual.html
set(CMAKE_INCLUDE_CURRENT_DIR ON) # for .moc
target_include_directories(${MODULE}
  PUBLIC $<INSTALL_INTERFACE:include>
  PUBLIC $<INSTALL_INTERFACE:include/${MODULE}>
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${MODULE}>
  PRIVATE ${EXTRA_INCLUDE}
  )
target_compile_definitions(${MODULE} PRIVATE ${EXTRA_DEFS})


install(FILES
  ${SDK_HEADERS}
  DESTINATION ${QTAV_INSTALL_HEADERS}/${MODULE}
)
install(FILES
  ${SDK_PRIVATE_HEADERS}
  DESTINATION ${QTAV_INSTALL_HEADERS}/${MODULE}/private
)
install(TARGETS ${MODULE}
  EXPORT ${MODULE}-targets
  #PUBLIC_HEADER DESTINATION ${QTAV_INSTALL_HEADERS}/${MODULE}
  #PRIVATE_HEADER DESTINATION ${QTAV_INSTALL_HEADERS}/${MODULE}/private
  RUNTIME DESTINATION ${QTAV_INSTALL_BINS}
  LIBRARY DESTINATION ${QTAV_INSTALL_LIBS}
  ARCHIVE DESTINATION ${QTAV_INSTALL_LIBS}
  FRAMEWORK DESTINATION ${QTAV_INSTALL_LIBS}
)
install(EXPORT ${MODULE}-targets
  DESTINATION ${QTAV_INSTALL_LIBS}/cmake/${MODULE}
  FILE ${MODULE}-config.cmake
)

=== debian/changelog ===
qtav (1.12.0.1+ds+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Debian Qt extras Maintainers <debian-qt-kde@lists.debian.org>  Fri, 29 Jan 2021 09:15:15 +0800

## qtav 1.13.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
+
+project(QTAV)
+
 set(QTAV_MAJOR 1)
-set(QTAV_MINOR 11)
+set(QTAV_MINOR 13)
 set(QTAV_PATCH 0)
 set(PROJECT_VERSION ${QTAV_MAJOR}.${QTAV_MINOR}.${QTAV_PATCH})
 set(SO_VERSION ${QTAV_MAJOR})
@@ -10,6 +13,9 @@
 
 if(POLICY CMP0063) # visibility. since 3.3
   cmake_policy(SET CMP0063 NEW)
+endif()
+if(POLICY CMP0071)
+  cmake_policy(SET CMP0071 NEW)
 endif()
 set(CMAKE_CXX_VISIBILITY_PRESET hidden) #use with -fdata-sections -ffunction-sections to reduce target size
 set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -101,7 +101,7 @@
   set(MODULE QMLPlayer)
   if(WIN32)
     set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
-    configure_file(${CMAKE_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
+    configure_file(${QTAV_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
   endif()
   add_executable(QMLPlayer ${EXE_TYPE}
       QMLPlayer/main.cpp
@@ -120,7 +120,7 @@
   set(MODULE Player)
   if(WIN32)
     set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
-    configure_file(${CMAKE_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
+    configure_file(${QTAV_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
   endif()
   add_executable(Player ${EXE_TYPE} ${PLAYER_SRC} ${PLAYER_HEADERS} ${PLAYER_RES} ${RC_FILE})
   target_link_libraries(Player QtAVWidgets common)

=== qml/CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 # add HEADERS for moc
 if(WIN32)
   set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
-  configure_file(${CMAKE_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
+  configure_file(${QTAV_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
 endif()
 add_library(${MODULE} SHARED ${SOURCES} ${RESOURCES_SOURCES} ${HEADERS} ${RC_FILE})
 target_link_libraries(${MODULE}

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -12,8 +12,8 @@
 include_directories(${QTDIR}/include) #TODO: remove. use external/include
 get_filename_component(QTDIR "${QTDIR}" ABSOLUTE)
 
-list(APPEND EXTRA_INCLUDE ${CMAKE_SOURCE_DIR}/external/include)
-list(APPEND EXTRA_LIBS ${CMAKE_LIBRARY_PATH_FLAG}${CMAKE_SOURCE_DIR}/external/lib)
+list(APPEND EXTRA_INCLUDE ${QTAV_SOURCE_DIR}/external/include)
+list(APPEND EXTRA_LIBS ${CMAKE_LIBRARY_PATH_FLAG}${QTAV_SOURCE_DIR}/external/lib)
 if(APPLE)
     if(IOS)
       #set_xcode_property(myioslib IPHONEOS_DEPLOYMENT_TARGET "8.0")
@@ -22,9 +22,9 @@
       list(APPEND EXTRA_LIBS -L/usr/local/lib)
     endif()
 endif()
-if(EXISTS ${CMAKE_SOURCE_DIR}/contrib/capi/capi.h)
+if(EXISTS ${QTAV_SOURCE_DIR}/contrib/capi/capi.h)
     set(HAVE_CAPI 1)
-    list(APPEND EXTRA_INCLUDE ${CMAKE_SOURCE_DIR}/contrib/capi) # TODO: only files use capi.h
+    list(APPEND EXTRA_INCLUDE ${QTAV_SOURCE_DIR}/contrib/capi) # TODO: only files use capi.h
     list(APPEND EXTRA_DEFS -DQTAV_HAVE_CAPI=1)
 endif()
 
@@ -324,7 +324,7 @@
 if(WIN32 OR WindowsStore OR WindowsPhone)
   check_include_files(XAudio2.h HAVE_XAUDIO2_H)
   if(NOT HAVE_XAUDIO2_H)
-    list(APPEND EXTRA_INCLUDE ${CMAKE_SOURCE_DIR}/contrib/dxsdk)
+    list(APPEND EXTRA_INCLUDE ${QTAV_SOURCE_DIR}/contrib/dxsdk)
   endif()
   message("Qt5Gui_EGL_INCLUDE_DIRS: ${Qt5Gui_EGL_INCLUDE_DIRS}")
   list(APPEND HEADERS

=== examples/simpleplayer/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
find_package(QtAV REQUIRED)
find_package(Qt5Widgets REQUIRED)
set(CMAKE_AUTOMOC ON)

add_executable(simpleplayer main.cpp playerwindow.cpp playerwindow.h)
target_include_directories(simpleplayer PRIVATE ${QTAVWIDGETS_INCLUDE_DIRS})
target_link_libraries(simpleplayer ${QTAVWIDGETS_LIBRARIES} Qt5::Widgets)

=== debian/changelog ===
qtav (1.13.0+ds-4build1) jammy; urgency=medium

  * No-change rebuild against Qt 5.15.3.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Thu, 17 Mar 2022 18:37:53 +0300

qtav (1.13.0+ds-4) unstable; urgency=medium

  * Team upload.

  [ Sebastian Ramacher ]
  * debian/control: Build-Depend on libswresample-dev instead of
    libavresample-dev (Closes: #971329)

  [ Pino Toscano ]
  * Bump Standards-Version to 4.6.0, no changes required.
  * Add the configuration for the CI on salsa.
  * Remove the explicit as-needed linking, as it is done by binutils now.
  * Drop query for DEB_BUILD_MULTIARCH in rules, as it is not used.
  * Add Rules-Requires-Root: no.
  * Switch the debhelper build dependency to debhelper-compat (same version)
    - remove debian/compat

 -- Pino Toscano <pino@debian.org>  Sat, 21 Aug 2021 12:32:50 +0200

qtav (1.13.0+ds-3) unstable; urgency=medium

  * Team upload.
  * Backport upstream patch to add missing include for Qt 5.15.
    (Closes: #972355)

 -- Dmitry Shachnev <mitya57@debian.org>  Wed, 21 Oct 2020 13:10:45 +0300

qtav (1.13.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Backport upstream patch to add missing include for Qt 5.14.
    (Closes: #960951)
  * Remove Section field for qtav-players that duplicates source.
  * Use spaces instead of tabs for indentation in debian/control.

 -- Dmitry Shachnev <mitya57@debian.org>  Tue, 02 Jun 2020 19:30:30 +0300

qtav (1.13.0+ds-1) unstable; urgency=medium

  [ Steven Robbins ]
  * [4ef3ad4] New upstream version 1.13.0+ds

 -- Steve M. Robbins <smr@debian.org>  Sat, 31 Aug 2019 18:20:39 -0500

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Steve M. Robbins <smr@debian.org>
 Section: video
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 11),
                qt5-qmake,
                libqt5opengl5-dev,
                libqt5svg5-dev,
@@ -11,11 +11,11 @@
                libqt5x11extras5-dev,
                libass-dev,
                libavutil-dev,
-               libavresample-dev,
                libavcodec-dev,
                libavformat-dev,
                libavdevice-dev,
                libavfilter-dev,
+               libswresample-dev,
                libswscale-dev,
                libopenal-dev,
                libpulse-dev,
@@ -23,7 +23,8 @@
                libva-dev [!hurd-any],
                libegl1-mesa-dev,
                libuchardet-dev
-Standards-Version: 4.1.5
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
 Homepage: http://qtav.org
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qtav
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qtav.git
@@ -99,13 +100,12 @@
 Package: qtav-players
 Architecture: any
 Multi-Arch: no
-Section: video
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          qml-module-qtav,
-	 qml-module-qtquick-dialogs,
-	 qml-module-qtquick-controls,
-	 qml-module-qt-labs-folderlistmodel
+         qml-module-qtquick-dialogs,
+         qml-module-qtquick-controls,
+         qml-module-qt-labs-folderlistmodel
 Pre-Depends: ${misc:Pre-Depends}
 Description: QtAV/QML players
  QtAV is a multimedia playback framework based on Qt and FFmpeg.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt5

%:
	dh $@ --buildsystem qmake

override_dh_auto_configure:
	dh_auto_configure -Sqmake -- CONFIG+="no_rpath recheck config_libass_link config_openal_link no-tests"
